/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.monitoring.core;


import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.hibernate.Session;
import org.spagic.metadb.dbutils.HibernateUtil;
import org.spagic.metadb.model.ProcessExecutionState;

public class ProcessExecutionStateCache {
	
	private static Map<Long, ProcessExecutionState> processExecutionStates = null;
	
	public static ProcessExecutionState getProcessExecutionState(long processExecutionStateID) {
		if (processExecutionStates == null) {
			loadProcessExecutionStates();
		}
		return processExecutionStates.get(processExecutionStateID);
	}
		
	@SuppressWarnings("unchecked")
	private synchronized static void loadProcessExecutionStates() {
		Session aSession = null;
		try {
			processExecutionStates = new HashMap<Long, ProcessExecutionState>();
			aSession = HibernateUtil.getSessionFactory().openSession();
			List<ProcessExecutionState> processExecutionStateList = 
					aSession.createQuery("from org.spagic.metadb.model.ProcessExecutionState")
							.list();
			for (ProcessExecutionState pes : processExecutionStateList) {
				processExecutionStates.put(pes.getIdProcessExecutionState(), pes);
			}
		}catch(Throwable t){
			t.printStackTrace();
		}finally{
			aSession.close();
		}
	}

}
